/*
 *	Copyright (c) 2024 Scott Duensing, scott@kangaroopunch.com
 *
 *	Permission is hereby granted, free of charge, to any person obtaining a copy
 *	of this software and associated documentation files (the "Software"), to deal
 *	in the Software without restriction, including without limitation the rights
 *	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *	copies of the Software, and to permit persons to whom the Software is
 *	furnished to do so, subject to the following conditions:
 *
 *	The above copyright notice and this permission notice shall be included in
 *	all copies or substantial portions of the Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *	SOFTWARE.
 */


#include "oc_save.h"
#include "interpreter.h"
#include "state.h"
#include "portme.h"
#include "story.h"
#include "opcodes.h"
#include "memory.h"
#include "window.h"


void opcodes_save(void) {
	interpreterDoBranch(portFileSave() ? 1 : 0);
}


void opcodes_restart(void) {
	byte     width    = ZPEEK(STORY_SCREEN_WIDTH_CHARACTERS);
	byte     height   = ZPEEK(STORY_SCREEN_HEIGHT_LINES);
	uint16_t checksum = __state.checksum;

	stateReset();
	portStoryLoad();
	__state.checksum = checksum;
	opcodesSetup();
	storySetup(width, height);
}


void opcodes_restore(void) {
	bool ok = portFileRestore();

	if (ok) {
		// Collapse upper window.
		__state.statusWindowLineCount = 0;
		windowSplit(0);
	}

	interpreterDoBranch(ok ? 1 : 0);
}
